/*
 * sflib.h --- SFLib syscall library for Linux/Alpha 
 * see http://www.secdev.org/projects/shellforge.html for more informations
 *
 * Copyright (C) 2004  Philippe Biondi <phil@secdev.org>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */


/*
 * Automatically generated by gensflib.py 
 * Sun Dec  5 01:07:50 2004
 */

#ifndef SFLIB_H
#define SFLIB_H

#define SF_BIGENDIAN


#include "sfsysnr.h"
#include "sfsyscall.h"
#include "../common/sftypes.h"
        

// osf_syscall
static inline _sfsyscall1(int, exit, int, status)
static inline _sfsyscall0( pid_t, fork )
static inline _sfsyscall3( ssize_t, read, int, fd, void *, buf, size_t, count )
static inline _sfsyscall3( ssize_t, write, int, fd, const void *, buf, size_t, count )
// osf_old_open
static inline _sfsyscall1( int, close, int, fd )
// osf_wait4
// osf_old_creat
static inline _sfsyscall2( int, link, const char *, oldpath, const char *, newpath )
static inline _sfsyscall1( int, unlink, const char *, pathname )
// osf_execve
static inline _sfsyscall1( int, chdir, const char *, path )
// fchdir
static inline _sfsyscall3( int, mknod, const char *, pathname, mode_t, mode, dev_t, dev )
static inline _sfsyscall2( int, chmod, const char *, path, mode_t, mode )
static inline _sfsyscall3( int, chown, const char *, path, uid_t, owner, gid_t, group )
static inline _sfsyscall1( int, brk, void *, end_data_segment )
// osf_getfsstat
static inline _sfsyscall3( off_t, lseek, int, fildes, off_t, offset, int, whence )
// getxpid
// osf_mount
static inline _sfsyscall1( int, umount, const char *, dir )
// setuid
// getxuid
// exec_with_loader
static inline _sfsyscall4(long, ptrace, int, request, pid_t, pid, void *,addr, void *,data)
// osf_nrecvmsg
// osf_nsendmsg
// osf_nrecvfrom
// osf_naccept
// osf_ngetpeername
// osf_ngetsockname
static inline _sfsyscall2( int, access, const char *, pathname, int, mode )
// osf_chflags
// osf_fchflags
static inline _sfsyscall0( int, sync )
static inline _sfsyscall2( int, kill, pid_t, pid, int, sig )
// osf_old_stat
static inline _sfsyscall2( int, setpgid, pid_t, pid, pid_t, pgid )
// osf_old_lstat
static inline _sfsyscall1( int, dup, int, oldfd )
static inline _sfsyscall1( int, pipe, unsigned long *, filedes)
// osf_set_program_attributes
// osf_profil
static inline _sfsyscall3( int, open, const char *, pathname, int, flags, mode_t, mode )
// osf_old_sigaction
// getxgid
// osf_sigprocmask
// osf_getlogin
// osf_setlogin
static inline _sfsyscall1( int, acct, const char *, filename )
static inline _sfsyscall1( int, sigpending, sigset_t *, set )
static inline _sfsyscall4(int, ioctl, int,d, int,request, char *,argp, int,len)
// osf_reboot
// osf_revoke
static inline _sfsyscall2( int, symlink, const char *, oldpath, const char *, newpath )
static inline _sfsyscall3( int, readlink, const char *, path, char *, buf, size_t, bufsiz )
static inline _sfsyscall3(int, execve, char *, s, char **, argv, char **,envp)
static inline _sfsyscall1( mode_t, umask, mode_t, mask )
static inline _sfsyscall1( int, chroot, const char *, path )
// osf_old_fstat
static inline _sfsyscall0( pid_t, getpgrp )
// getpagesize
// osf_mremap
static inline _sfsyscall0( pid_t, vfork )
static inline _sfsyscall2( int, stat, const char *, file_name, struct stat *, buf )
static inline _sfsyscall2( int, lstat, const char *, file_name, struct stat *, buf )
// osf_sbrk
// osf_sstk
static inline _sfsyscall6(void *,mmap, void *,start, size_t,length, int,prot , int,flags, int,fd, off_t,offset)
// osf_old_vadvise
static inline _sfsyscall2( int, munmap, void *, start, size_t, length )
static inline _sfsyscall3( int, mprotect, const void *, addr, size_t, len, int, prot )
// madvise
static inline _sfsyscall0( int, vhangup )
// osf_kmodcall
// osf_mincore
// getgroups
static inline _sfsyscall2( int, setgroups, size_t, size, const gid_t *, list )
// osf_old_getpgrp
// setpgrp
// osf_setitimer
// osf_old_wait
// osf_table
// osf_getitimer
// gethostname
static inline _sfsyscall2( int, sethostname, const char *, name, size_t, len )
// getdtablesize
static inline _sfsyscall2( int, dup2, int, oldfd, int, newfd )
static inline _sfsyscall2( int, fstat, int, filedes, struct stat *, buf )
static inline _sfsyscall3( int, fcntl, int, fd, int, cmd, long, arg )
// osf_select
static inline _sfsyscall3( int, poll, struct pollfd *, ufds, unsigned int, nfds, int, timeout )
static inline _sfsyscall1( int, fsync, int, fd )
static inline _sfsyscall3( int, setpriority, int, which, int, who, int, prio )
static inline _sfsyscall3(int, socket, int,domain, int,type, int,protocol)
static inline _sfsyscall3(int,connect, int,sockfd, const struct sockaddr *,serv_addr, socklen_t,addrlen)
static inline _sfsyscall3(int, accept, int,s, struct sockaddr *,addr, socklen_t,*addrlen);
static inline _sfsyscall2( int, getpriority, int, which, int, who )
static inline _sfsyscall4(int,send,  int,s, const void *,msg, size_t,len, int,flags);
// recv
static inline _sfsyscall1( int, sigreturn, unsigned long, __unused )
static inline _sfsyscall3(int, bind, int,sockfd, struct sockaddr *,my_addr, socklen_t,addrlen)
// setsockopt
static inline _sfsyscall2(int,listen,int,s, int,backlog)
// osf_plock
// osf_old_sigvec
// osf_old_sigblock
// osf_old_sigsetmask
static inline _sfsyscall1( int, sigsuspend, const sigset_t *, mask )
// osf_sigstack
// recvmsg
// sendmsg
// osf_old_vtrace
// osf_gettimeofday
// osf_getrusage
// getsockopt
static inline _sfsyscall3( int, readv, int, fd, const struct iovec *, vector, int, count )
static inline _sfsyscall3( int, writev, int, fd, const struct iovec *, vector, int, count )
// osf_settimeofday
static inline _sfsyscall3( int, fchown, int, fd, uid_t, owner, gid_t, group )
static inline _sfsyscall2( int, fchmod, int, fildes, mode_t, mode )
// recvfrom
static inline _sfsyscall2( int, setreuid, uid_t, ruid, uid_t, euid )
static inline _sfsyscall2( int, setregid, gid_t, rgid, gid_t, egid )
static inline _sfsyscall2( int, rename, const char *, oldpath, const char *, newpath )
static inline _sfsyscall2( int, truncate, const char *, path, off_t, length )
static inline _sfsyscall2( int, ftruncate, int, fd, off_t, length )
// flock
// setgid
// sendto
// shutdown
// socketpair
static inline _sfsyscall2( int, mkdir, const char *, pathname, mode_t, mode )
static inline _sfsyscall1( int, rmdir, const char *, pathname )
// osf_utimes
// osf_old_sigreturn
// osf_adjtime
// getpeername
// osf_gethostid
// osf_sethostid
// getrlimit
// setrlimit
// osf_old_killpg
static inline _sfsyscall0( pid_t, setsid )
// quotactl
// osf_oldquota
// getsockname
// osf_pid_block
// osf_pid_unblock
// sigaction
// osf_sigwaitprim
// osf_nfssvc
// osf_getdirentries
// osf_statfs
// osf_fstatfs
// osf_asynch_daemon
// osf_getfh
// osf_getdomainname
static inline _sfsyscall2( int, setdomainname, const char *, name, size_t, len )
// osf_exportfs
// osf_alt_plock
// osf_getmnt
// osf_alt_sigpending
// osf_alt_setsid
// osf_swapon
// msgctl
// msgget
// msgrcv
// msgsnd
// semctl
// semget
// semop
// osf_utsname
static inline _sfsyscall3( int, lchown, const char *, path, uid_t, owner, gid_t, group )
// osf_shmat
// shmctl
// shmdt
// shmget
// osf_mvalid
// osf_getaddressconf
// osf_msleep
// osf_mwakeup
static inline _sfsyscall3( int, msync, const void *, start, size_t, length, int, flags )
// osf_signal
// osf_utc_gettime
// osf_utc_adjtime
// osf_security
// osf_kloadcall
static inline _sfsyscall1( pid_t, getpgid, pid_t, pid )
static inline _sfsyscall1( pid_t, getsid, pid_t, pid )
// sigaltstack
// osf_waitid
// osf_priocntlset
// osf_sigsendset
// osf_set_speculative
// osf_msfs_syscall
// osf_sysinfo
// osf_uadmin
// osf_fuser
// osf_proplist_syscall
// osf_ntp_adjtime
// osf_ntp_gettime
// osf_pathconf
// osf_fpathconf
// osf_uswitch
// osf_usleep_thread
// osf_audcntl
// osf_audgen
static inline _sfsyscall3( int, sysfs, int, option, unsigned int, fs_index, char *, buf )
// osf_subsys_info
// osf_getsysinfo
// osf_setsysinfo
// osf_afs_syscall
// osf_swapctl
// osf_memcntl
// osf_fdatasync
// bdflush
// sethae
// mount
// old_adjtimex
static inline _sfsyscall1( int, swapoff, const char *, path )
static inline _sfsyscall3( int, getdents, unsigned int, fd, struct dirent *, dirp, unsigned int, count )
static inline _sfsyscall2( caddr_t, create_module, const char *, name, size_t, size )
static inline _sfsyscall2( int, init_module, const char *, name, struct module *, image )
static inline _sfsyscall1( int, delete_module, const char *, name )
static inline _sfsyscall1( int, get_kernel_syms, struct kernel_sym *, table )
static inline _sfsyscall3( int, syslog, int, type, char *, bufp, int, len )
// reboot
// clone
static inline _sfsyscall1( int, uselib, const char *, library )
static inline _sfsyscall2( int, mlock, const void *, addr, size_t, len )
static inline _sfsyscall2( int, munlock, const void *, addr, size_t, len )
static inline _sfsyscall1( int, mlockall, int, flags )
static inline _sfsyscall0( int, munlockall )
static inline _sfsyscall1( int, sysinfo, struct sysinfo *, info )
// oldumount
static inline _sfsyscall2( int, swapon, const char *, path, int, swapflags )
static inline _sfsyscall1( clock_t, times, struct tms *, buf )
static inline _sfsyscall1( int, personality, unsigned long, persona )
static inline _sfsyscall1( int, setfsuid, uid_t, fsuid )
static inline _sfsyscall1( int, setfsgid, uid_t, fsgid )
static inline _sfsyscall2( int, ustat, dev_t, dev, struct ustat *, ubuf )
static inline _sfsyscall2( int, statfs, const char *, path, struct statfs *, buf )
static inline _sfsyscall2( int, fstatfs, int, fd, struct statfs *, buf )
static inline _sfsyscall2( int, sched_setparam, pid_t, pid, const struct sched_param *, p )
static inline _sfsyscall2( int, sched_getparam, pid_t, pid, struct sched_param *, p )
// sched_setscheduler
static inline _sfsyscall1( int, sched_getscheduler, pid_t, pid )
static inline _sfsyscall0( int, sched_yield )
static inline _sfsyscall1( int, sched_get_priority_max, int, policy )
static inline _sfsyscall1( int, sched_get_priority_min, int, policy )
static inline _sfsyscall2( int, sched_rr_get_interval, pid_t, pid, struct timespec *, tp )
// afs_syscall
static inline _sfsyscall1( int, uname, struct utsname *, buf )
static inline _sfsyscall2( int, nanosleep, const struct timespec *, req, struct timespec *, rem )
// mremap
// nfsservctl
static inline _sfsyscall3( int, setresuid, uid_t, ruid, uid_t, euid, uid_t, suid )
static inline _sfsyscall3( int, getresuid, uid_t *, ruid, uid_t *, euid, uid_t *, suid )
// pciconfig_read
// pciconfig_write
// query_module
// prctl
static inline _sfsyscall4( ssize_t, pread, int, fd, void *, buf, size_t, count, off_t, offset )
// pwrite
// rt_sigreturn
// rt_sigaction
// rt_sigprocmask
// rt_sigpending
// rt_sigtimedwait
// rt_sigqueueinfo
// rt_sigsuspend
static inline _sfsyscall5( int, select, int,  n, fd_set *, readfds, fd_set *, writefds, fd_set *, exceptfds, struct timeval *, timeout)
static inline _sfsyscall2( int, gettimeofday, struct timeval *, tv, struct timezone *, tz )
// settimeofday
// getitimer
// setitimer
// utimes
// getrusage
// wait4
// adjtimex
// getcwd
static inline _sfsyscall2( int, capget, cap_user_header_t, header, cap_user_data_t, data )
static inline _sfsyscall2( int, capset, cap_user_header_t, header, const cap_user_data_t, data )
// sendfile
// setresgid
// getresgid
// dipc
// pivot_root
// mincore
// pciconfig_iobase
// getdents64
// gettid
// readahead
// security
static inline _sfsyscall0( pid_t, getpid )
static inline _sfsyscall0( uid_t, getuid )
static inline _sfsyscall0( gid_t, getgid )


#endif /* SFLIB_H */
